#include "svg.h"
#include <iostream>

void svg_begin(double width, double height) {
    std::cout << "<?xml version='1.0' encoding='UTF-8'?>\n";
    std::cout << "<svg width='" << width << "' height='" << height << "' "
              << "viewBox='0 0 " << width << " " << height << "' "
              << "xmlns='http://www.w3.org/2000/svg'>\n";
}

void svg_end() {
    std::cout << "</svg>\n";
}

void svg_text(double left, double baseline, const std::string& text) {
    std::cout << "<text x='" << left << "' y='" << baseline << "'>" << text << "</text>\n";
}

void svg_rect(double x, double y, double width, double height,
              const std::string& stroke, const std::string& fill) {
    std::cout << "<rect x='" << x << "' y='" << y << "' "
              << "width='" << width << "' height='" << height << "' "
              << "stroke='" << stroke << "' fill='" << fill << "' />\n";
}

/*void show_histogram_svg(const std::vector<size_t>& bins) {
    const size_t IMAGE_WIDTH = 400;
    const size_t IMAGE_HEIGHT = 300;
    const size_t TEXT_LEFT = 20;
    const size_t TEXT_BASELINE = 20;
    const size_t TEXT_WIDTH = 50;
    const size_t BIN_HEIGHT = 30;
    const size_t BLOCK_WIDTH = 10;

    svg_begin(IMAGE_WIDTH, IMAGE_HEIGHT);

    double top = 0;
    size_t max_count = 0;
    for (size_t count : bins) {
        if (count > max_count) max_count = count;
    }

    for (size_t bin : bins) {
        const double bin_width = static_cast<double>(bin) / max_count * (IMAGE_WIDTH - TEXT_WIDTH);
        svg_text(TEXT_LEFT, top + TEXT_BASELINE, std::to_string(bin));
        svg_rect(TEXT_WIDTH, top, bin_width, BIN_HEIGHT, "black", "#aaffaa");
        top += BIN_HEIGHT;
    }

    svg_end();
}*/
void show_histogram_svg(const std::vector<size_t>& bins) {
    size_t max_count = 0;
    for (size_t count : bins) {
        if (count > max_count) max_count = count;
    }

    const size_t IMAGE_HEIGHT = IMAGE_PADDING * 2 + max_count * 10 + TEXT_HEIGHT;

    svg_begin(IMAGE_WIDTH, IMAGE_HEIGHT);

    double x = IMAGE_PADDING;
    const double y_base = IMAGE_HEIGHT - IMAGE_PADDING - TEXT_HEIGHT;

    for (size_t bin : bins) {
        const double height = bin * 10;
        svg_rect(x, y_base - height, BAR_WIDTH, height, "black", "#aaffaa");
        svg_text(x + BAR_WIDTH/2 - 5, y_base + TEXT_HEIGHT - 5, std::to_string(bin));

        x += BAR_WIDTH + 10;
    }

    svg_end();
}
